<?php
 /**
  * 
  * @package    Whatsapp chat support - WordPress plugin
  * @version    1.0
  * @author     ThemeAtelier
  * @Websites: https://themeatelier.net/
  *
  */
 if( ! defined( 'ABSPATH' ) ) {
    die( CTW_ALERT_MSG );
}

if( !class_exists( 'Ctw_Enqueue' ) ){
	class Ctw_Enqueue{
		public function __construct( $args = array() ) {
			add_action( 'wp_enqueue_scripts', array( $this, 'frontend_enqueue_scripts' ) );
		}
		// Front-End enqueue scripts
		public function frontend_enqueue_scripts() {
			$options = get_option('ctw-opt');
			$waCustomCss = isset($options['whatsapp-custom-css']) ? $options['whatsapp-custom-css'] : '';
			$waCustomJs = isset($options['whatsapp-custom-js']) ? $options['whatsapp-custom-js'] : '';
			$auto_show_popup = isset($options['autoshow-popup']) ? $options['autoshow-popup'] : '';
			$auto_open_popup_timeout = isset($options['auto_open_popup_timeout']) ? $options['auto_open_popup_timeout'] : 0;

			wp_enqueue_style( 'fontawesome', CTW_DIR_URL.'assets/css/all.min.css', array(), '1.0', false );
			wp_enqueue_style( 'ctw-main', CTW_DIR_URL.'assets/css/ctw-main.css', array(), '1.0', false );
			wp_enqueue_style( 'ctw-custom-style', CTW_DIR_URL.'assets/css/ctw-custom.css', array(), '1.0.2', false );

			$custom_css = '';
			if ($waCustomCss) {
				$custom_css .= $waCustomCss;
			}

			wp_add_inline_style('ctw-custom-style', $custom_css);

			/********************
				Js Enqueue
			********************/
			wp_enqueue_script('moment', array('jquery'), '1.0',true);
			wp_enqueue_script( 'moment-timezone', CTW_DIR_URL.'assets/js/moment-timezone-with-data.min.js', array('jquery'), '1.0', true );
			wp_enqueue_script( 'ctw-main', CTW_DIR_URL.'assets/js/ctw-main.js', array('jquery'), '1.0', true );

			$frontend_scripts = array(
				'autoShowPopup' 		=> $auto_show_popup,
				'autoOpenPopupTimeout' 	=> $auto_open_popup_timeout,
			);

			wp_localize_script( 'ctw-main', 'whatshelp_pro_frontend_script', $frontend_scripts);

			if (!empty($waCustomJs)) {
				wp_add_inline_script('ctw-main', $waCustomJs);
			}
		}
	}

	$obj = new Ctw_Enqueue();
}

